import * as React from 'react';
import * as ReactDOM from 'react-dom';
import GC from '@grapecity/spread-sheets';
import { SpreadSheets, Worksheet } from '@grapecity/spread-sheets-react';
import '@grapecity/spread-sheets-resources-zh';
import "@grapecity/spread-sheets/styles/gc.spread.sheets.excel2013white.css"
GC.Spread.Common.CultureManager.culture("zh-cn");


const colInfos = [{ name: "行号", width: 100, aling: "right" },
 { name: "项目名称", width: 150 }, 
 { name: "计量单位", width: 65 },
{ name: "数量", width: 100 }, 
{ name: "单价", width: 100 },
{ name: "合价", width: 100 },
{ name: "备注", width: 150 }];
let wHeight = 800;
let wWidth = 800;
let self = null;

var dayWokdataList = [];
var saveData = null;
var projectId = null;


function initOutlineColumn(sheet) {
    sheet.outlineColumn.options({
        columnIndex: 0,
        //showImage: true,
        showCheckBox: true,
        showIndicator: true,
        expandIndicator: false
        /* images: ['$DEMOROOT$/spread/source/images/archiverFolder.png', '$DEMOROOT$/spread/source/images/newFloder.png', '$DEMOROOT$/spread/source/images/docFile.png'],
        expandIndicator: '$DEMOROOT$/spread/source/images/increaseIndicator.png',
        collapseIndicator: '$DEMOROOT$/spread/source/images/decreaseIndicator.png',
        maxLevel: 2 */
    });
    sheet.showRowOutline(true);
    sheet.outlineColumn.refresh();
}

function initContextMenu(spread, sheet) {

    function ContextMenu(){}
    ContextMenu.prototype = new GC.Spread.Sheets.ContextMenu.ContextMenu(spread);
    ContextMenu.prototype.onOpenMenu = function (menuData, itemsDataForShown, hitInfo, spread) {
        console.log(menuData);
        console.log(itemsDataForShown);
        console.log(hitInfo);
        console.log(sheet.options.isProtected)
        if(sheet.options.isProtected) {
            for(let i=0; i<menuData.length; i++){
            var item = menuData[i];
            if(item.name === "gc.spread.insertComment"){
                itemsDataForShown.push(item);
            }
        }
        }
    };
    spread.contextMenu = new ContextMenu();

    var menus = [{
        iconClass: "gc-spread-pasteAll",
        name: "gc.spread.pasteOptions",
        text: "粘贴",
        command: "gc.spread.contextMenu.pasteAll",
        workArea: "viewportcolHeaderrowHeadercorner"
    },   {text: "复制", name: "gc.spread.copy", command: "gc.spread.contextMenu.copy", iconClass: "gc-spread-copy", workArea: "viewportcolHeaderrowHeaderslicercorner"},{
            text: "插入",
            name: "gc.spread.insertRowData",
            command: "insertRowsBehind",
            iconClass: "gc-spread-tableInsertRowsBelow",
            workArea: "viewportcolHeaderrowHeadercorner"
        }, {
            text: "删除",
            name: "gc.spread.tableDeleteRows",
            command: "deleteRows",
            iconClass: "gc-spread-tableDeleteRows",
            workArea: "viewportcolHeaderrowHeadercorner"
        }, {
            command: "gc.spread.contextMenu.insertComment",
            iconClass: "gc-spread-insertComment",
            name: "gc.spread.insertComment",
            text: "插入批注",
            workArea: "viewportcorner"
        },{
            text: "编辑批注",
            name: "gc.spread.editComment",
            command: "gc.spread.contextMenu.editComment",
            iconClass: "gc-spread-editComment",
            workArea: "viewportcorner"
        }/* {
            text: "撤销",
            name: "gc.spread.oUndo",
            command: "oUndo",
            //iconClass: "gc-spread-tableDeleteRows",
            workArea: "viewportcolHeaderrowHeadercorner"
        }, {
            text: "恢复",
            name: "gc.spread.oRedo",
            command: "oRedo",
            //iconClass: "gc-spread-tableDeleteRows",
            workArea: "viewportcolHeaderrowHeadercorner"
        }, */
    ];

    var menuData = spread.contextMenu.menuData;
    spread.contextMenu.menuData = menus;
}



/**
 * 插入一行新数据*/
function addItem(spread, line, lineCode, indent, isRefresh) {
    try {
        let sheet = spread.getActiveSheet();
        sheet.addRows(line, 1);
        dayWokdataList[line].行号 = lineCode;
        //dayWokdataList[line].项目名称 = lineCode;
        dayWokdataList[line].计量单位 = "元";
        //dayWokdataList[line].合价 = "=(D"+(line*1+1*1)+")*(E"+(line*1+1*1)+")";
        //sheet.setFormula(line*1+1*1, 6, "=(D"+(line*1+1*1)+")*(E"+(line*1+1*1)+")");
        dayWokdataList[line].indent = 3;
        var cell = sheet.getCell(line, 0, GC.Spread.Sheets.SheetArea.viewport);
        cell.textIndent(indent);
        if (isRefresh) {
            sheet.outlineColumn.refresh();
            spread.resumePaint();
        }
        //saveJrgData();
    } catch (ex) {
        console.log("-------error:------");
        console.log(ex);
    }

}


function saveJrgData() {
    var objData = {
        "jrgData": dayWokdataList,
        "dwgcId": "bbb",
        "projectId": projectId
    }
    /* var retPromise = saveData(objData);
    retPromise.then(ret => {
        if (ret != true) {
            console.log("--------------:数据保存出错");
        }
    }) */
    return true;
}

class SpreadJsDEMO extends React.Component {
    constructor(props) {
        super(props);
        saveData = this.saveUnitProject;
        wHeight = window.innerHeight - 198;
        wWidth = parseInt(window.innerWidth) - 200;
        projectId = "bbb";
        this.state = {
            width: wWidth,
            height: wHeight,
            projectModel: {
                "projectId": projectId,
                "dwgcId": "aaa",
                "dwgcmc":"bb",
                "jrgData": null//计日工 data
            }

        };
        this.spread = null;
        
        

    }
    
    componentDidMount() {
        //this.props.onRef(this)

    }

    componentWillUnmount() {

    }

     // 在componentWillReceiveProps中使用redux中涉及的变量
     componentWillReceiveProps(nextProps) {
        if (nextProps.load !== this.props.load) {
            this.loadInstance = nextProps.load;
            console.log("props receive load");
            this.loadInstance.queryLoads(true);
        }
    }


    getItems(count) {

        var item = this.getItemDataModel();
        item.行号 = 1;
        item.项目名称 = "计日工";
        item.indent = 1;
        dayWokdataList.push(item);
        item = this.getItemDataModel();
        item.行号 = "1.1";
        item.项目名称 = "零星人工";
        item.indent = 2;
        dayWokdataList.push(item);
        item = this.getItemDataModel();
        item.行号 = "1.2";
        item.项目名称 = "零星材料";
        item.indent = 2;
        dayWokdataList.push(item);
        item = this.getItemDataModel();
        item.行号 = "1.3";
        item.项目名称 = "零星机械";
        item.indent = 2;
        dayWokdataList.push(item);

        /* item = this.getItemDataModel();
        item.行号 = "1.5";
        item.项目名称 = "XXX";
        item.indent = 2;
        dayWokdataList.push(item);
        for (var i = 0; i < 10000; i++) {
            item = this.getItemDataModel();
            item.行号 = "1." + i;
            item.项目名称 = "XXX" + i;
            item.indent = 2;
            dayWokdataList.push(item);
        } */
        return dayWokdataList;
    }

    initSpread(freeSpread) {
        freeSpread.suspendPaint();
        /*插入数据*/
        freeSpread.commandManager().register("insertRowsBehind", {
            canUndo: true,
            canRedo:true,
            execute: function (context, options, isUndo) {
                var currentRow = dayWokdataList[options.selections[0].row];
                //debugger;
                if (currentRow) {
                    var lineCode = currentRow.行号;
                    let sheet = freeSpread.getActiveSheet();
                    //console.log("--getDataSource---");
                    //console.log( sheet.getDataSource());//获取元数据
                    var codeArr = lineCode.split(".");
                    if (codeArr.length == 1) {
                        return;
                    } else if (codeArr.length == 2) {
                        if (options.selections[0].row == (sheet.getRowCount() - 1)) {
                            //debugger;
                            //dayWokdataList.push([]);
                            var tempCode = dayWokdataList[options.selections[0].row].行号;
                            var tempCodeArr = tempCode.split(".");
                            var newCode = tempCodeArr[0] + "." + tempCodeArr[1] + "." + 1;
                            try {
                                addItem(freeSpread, (options.selections[0].row + 1), newCode, 3, true);
                            } catch (ex) {
                                console.log("-----------" + ex.toString())
                            }
                            return;
                        }
                        for (var i = (options.selections[0].row * 1 + 1 * 1); i <= sheet.getRowCount(); i++) {
                            var nextCodeArr = dayWokdataList[i].行号.split(".");
                            if ((nextCodeArr.length != 3) || (i == (sheet.getRowCount() - 1))) {
                                var tempCode = dayWokdataList[i].行号;
                                var tempCodeArr = tempCode.split(".");
                                if ((tempCodeArr.length == 2) && (i == (options.selections[0].row * 1 + 1 * 1))) {
                                    tempCode = dayWokdataList[i - 1].行号;
                                    var tempCodeArr = tempCode.split(".");
                                    var newCode = tempCodeArr[0] + "." + tempCodeArr[1] + "." + 1;
                                    addItem(freeSpread, i, newCode, 3, true);
                                    break;
                                } else if (tempCodeArr.length == 2) {
                                    var tempCode = dayWokdataList[i - 1].行号;
                                    var tempCodeArr = tempCode.split(".");
                                    var newCode = tempCodeArr[0] + "." + tempCodeArr[1] + "." + (parseInt(tempCodeArr[2]) + 1);
                                    addItem(freeSpread, i, newCode, 3, true);
                                    break;
                                } else if (i == (sheet.getRowCount() - 1)) {
                                    var tempCode = dayWokdataList[i].行号;
                                    var tempCodeArr = tempCode.split(".");
                                    var newCode = tempCodeArr[0] + "." + tempCodeArr[1] + "." + (parseInt(tempCodeArr[2]) + 1);
                                    addItem(freeSpread, i + 1, newCode, 3, true);
                                    break;
                                }
                            }
                        }
                        return;
                    } else if (codeArr.length == 3) {
                        if (options.selections[0].row == (sheet.getRowCount() - 1)) {
                            //dayWokdataList.push([]);
                            var tempCode = dayWokdataList[options.selections[0].row].行号;
                            var tempCodeArr = tempCode.split(".");
                            var newCode = tempCodeArr[0] + "." + tempCodeArr[1] + "." + (tempCodeArr[2] * 1 + 1 * 1);
                            addItem(freeSpread, (options.selections[0].row + 1), newCode, 3, false);
                        } else {
                            var tempCode = dayWokdataList[options.selections[0].row].行号;
                            var tempCodeArr = tempCode.split(".");
                            var newCode = tempCodeArr[0] + "." + tempCodeArr[1] + "." + parseInt(tempCodeArr[2])
                            addItem(freeSpread, options.selections[0].row, newCode, 3, false);
                            for (var i = (options.selections[0].row * 1 + 1 * 1); i <= dayWokdataList.length; i++) {
                                var nextCodeArr = dayWokdataList[i].行号.split(".");
                                if (nextCodeArr.length == 3) {
                                    dayWokdataList[i].行号 = nextCodeArr[0] + "." + nextCodeArr[1] + "." + (parseInt(nextCodeArr[2]) + 1);
                                } else {

                                    break;
                                }
                            }
                        }
                        sheet.outlineColumn.refresh();
                        freeSpread.resumePaint();
                        return;
                    }
                }
                return;
            }
        });


        freeSpread.commandManager().register("deleteRows", {
            canUndo: true,
            canRedo:true,
            execute: function (context, options, isUndo) {
                //var currentRow = dayWokdataList[options.selections[0].row];
                var currentRow = dayWokdataList[options.selections[0].row];
                if (currentRow) {
                    var lineCode = currentRow.行号;
                    let sheet = freeSpread.getActiveSheet();
                    var codeArr = lineCode.split(".");
                    if (codeArr.length == 3) {
                        sheet.deleteRows(options.selections[0].row, 1);
                        for (var i = (options.selections[0].row * 1); i <= sheet.getRowCount(); i++) {
                            var nextCodeArr = dayWokdataList[i].行号.split(".");
                            if ((nextCodeArr.length != 3) || (i == (sheet.getRowCount() - 1))) {
                                break;
                            }
                            dayWokdataList[i].行号 = nextCodeArr[0] + "." + nextCodeArr[1] + "." + (parseInt(nextCodeArr[2]) - 1);
                        }
                        saveJrgData();
                        sheet.outlineColumn.refresh();
                        freeSpread.resumePaint();
                        return;
                    }
                }
                return;
            }
        });



        freeSpread.options.allowUndo = true;
        freeSpread.options.allowRedo = true;

        this.freeSpread = freeSpread;


      

            //var itmes = this.getItems();    
            this.getItems();


            var sheet = freeSpread.getSheet(0);
            //sheet.options.isProtected = true;
            freeSpread.isPaintSuspended(true);
            sheet.name("计日工");
            sheet.setDataSource(dayWokdataList);
            sheet.frozenColumnCount(1);//冻结
            sheet.options.protectionOptions = {
                allowSelectLockedCells: true, //用户是否可以选中被锁定的单元格
                allowSelectUnlockedCells: true,//用户是否可以选中未被锁定的单元格
                allowSort: false,//是否排序
                allowInsertColumns: true //是否可插入列
            };
            //freeSpread.Common.CultureManager.culture("zh-cn");
            freeSpread.options.tabStripVisible = false;
            sheet.bindColumns(colInfos);

            for (var i = 0; i < dayWokdataList.length; i++) {
                sheet.getCell(i, 0).textIndent(dayWokdataList[i].indent);
                var cell = sheet.getCell(i, 0, GC.Spread.Sheets.SheetArea.viewport);
                cell.textIndent(dayWokdataList[i].indent);
                cell.hAlign(GC.Spread.Sheets.HorizontalAlign.left);
                //cell.vAlign(GC.Spread.Sheets.VerticalAlign.center);
            } 
           

            sheet.outlineColumn.options({
                columnIndex: 0,
                showIndicator: true,
                expandIndicator: true
            });

           
            //console.log(freeSpread.contextMenu.menuData);

            try {
                let style = new GC.Spread.Sheets.Style();
                style.locked = false;
                sheet.setStyle(-1, 4, style);
                sheet.setStyle(-1, 3, style);
                sheet.setStyle(-1, 1, style);
                //sheet.setStyle(1, -1, style);
                for (var i = 0; i < dayWokdataList.length; i++) {
                    var item = dayWokdataList[i];
                    var code = item.行号.toString();
                    if (code.split(".").length == 3) {
                        sheet.getRange(i, 3, i, 4).locked(false);
                        sheet.getRange(i, 1, i, 1).locked(false);
                    } else {
                        let style1 = new GC.Spread.Sheets.Style();
                        style1.locked = true;
                        sheet.setStyle(i, -1, style1);
                    }
                    //sheet.getRange(0,1, 0, 1).locked(true);
                }
                //设置表单保护后，右键菜单批注不显示
                //sheet.options.isProtected = true;
                

            } catch (ex) {
                console.log("$$$$$$$$$");
                console.log(ex);
            }
            sheet.getRange("B:B", GC.Spread.Sheets.SheetArea.viewport).hAlign(GC.Spread.Sheets.HorizontalAlign.left);
            sheet.getRange("C:C", GC.Spread.Sheets.SheetArea.viewport).hAlign(GC.Spread.Sheets.HorizontalAlign.center);
            sheet.getRange("F:F", GC.Spread.Sheets.SheetArea.viewport).hAlign(GC.Spread.Sheets.HorizontalAlign.right);
            sheet.outlineColumn.refresh();

            freeSpread.isPaintSuspended(false);
            freeSpread.resumePaint();
            //sheet.getRange(-1, 0, -1, 0, GC.Spread.Sheets.SheetArea.viewport).hAlign(GC.Spread.Sheets.HorizontalAlign.left);
            //sheet.getRange(-1, 1, -1, 1, GC.Spread.Sheets.SheetArea.viewport).hAlign(GC.Spread.Sheets.HorizontalAlign.left);

           // sheet.getRange(-1, 2, -1, 2, GC.Spread.Sheets.SheetArea.viewport).hAlign(GC.Spread.Sheets.HorizontalAlign.center);
            GC.Spread.Common.CultureManager.culture("zh-cn");

            freeSpread.bind(GC.Spread.Sheets.Events.CellChanged, function (e, info) {
                if (info.sheetArea === GC.Spread.Sheets.SheetArea.viewport) {
                    try {

                        if ((info.col != 3) && (info.col != 4)) return;
                        if (isNaN(info.newValue)) {
                            console.log("----:数据不合规" + info.newValue);
                            return false;
                        } else if (info.newValue == info.oldValue) {
                            console.log(info.newValue + "--------" + info.oldValue);
                            console.log("----:新数据和老数据一致");
                            return false;
                        }

                    } catch (ex) {
                        console.log("^^^^^error^^^^^^:" + ex.toString());
                        console.log(ex.toString());
                    }


                }
            });

            initContextMenu(this.freeSpread, sheet);




    }

    getItemDataModel() {
        var item = {
            "行号": "1",
            "项目名称": "",
            "计量单位": "元",
            "数量": "",
            "单价": "",
            "合价": "",
            "备注": ""
        };
        return item;
    }


    undo(){
        console.log("计日工：我要回退--------------");
        var undoManager = this.freeSpread.undoManager();
         undoManager.undo();
    }

    redo(){
        console.log("计日工：我要撤销回退--------------");
        var undoManager = this.freeSpread.undoManager();
        undoManager.redo();
    }

    render() {


        return (
            <div>
                {/* <LinkButton style={{ width: 80 }} onClick={(e) => this.undo()}>回退</LinkButton>
                <LinkButton style={{ width: 80 }} onClick={(e) => this.redo()}>恢复</LinkButton> */}

                <SpreadSheets hostStyle={{ width: this.state.width, height: this.state.height }} workbookInitialized={spread => this.initSpread(spread)}>
                    <Worksheet>
                    </Worksheet>
                </SpreadSheets>
            </div>

        );
    }



}

export default SpreadJsDEMO;//Daywork

